"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.baseRouter = void 0;
const express_1 = require("express");
const base_record_1 = require("../records/base.record");
const seed_record_1 = require("../records/seed.record");
const errors_1 = require("../utils/errors");
exports.baseRouter = (0, express_1.Router)();
exports.baseRouter
    .get('/', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const basesList = yield base_record_1.BaseRecord.listAll();
    const seedsList = yield seed_record_1.SeedRecord.listAll();
    res.json({
        basesList,
        seedsList,
    });
}))
    .get('/:idBase', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const base = yield base_record_1.BaseRecord.getOne(req.params.idBase);
    const amountOfBases = yield base.countGivenBases();
    res.json({
        base,
    });
}))
    .post('/', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const newBase = new base_record_1.BaseRecord(req.body);
    yield newBase.insert();
    res.json(newBase);
}))
    .patch('/seed/:idBase', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    const { body } = req;
    //I am not sure this path /base/:idBase is correct
    const base = yield base_record_1.BaseRecord.getOne(req.params.idBase); // get one base
    if (base === null) {
        throw new errors_1.ValidationError('The base of bread you are looking for does not exist.');
    }
    const seed = body.seedId === '' ? null : yield seed_record_1.SeedRecord.getOne(body.seedId); // get one seed
    if (seed === null) {
        throw new errors_1.ValidationError('Such an addition to bread does not exist.');
    }
    base.seedId = (_a = seed === null || seed === void 0 ? void 0 : seed.idSeed) !== null && _a !== void 0 ? _a : null;
    yield base.update();
    res.json(base);
}))
    .patch('/base/:idBase', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const { body } = req;
    const base = yield seed_record_1.SeedRecord.getOne(req.params.idBase); // get one seed
    if (base === null) {
        throw new errors_1.ValidationError('The base witch you are looking for does not exist.');
    }
    base.count = body.newCount;
    try {
        yield base.update();
        res.json(base);
    }
    catch (error) {
        console.error('Error while updating the base record:', error);
        throw error;
    }
}));
//# sourceMappingURL=base.js.map