"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.seedRouter = void 0;
const express_1 = require("express");
const errors_1 = require("../utils/errors");
const seed_record_1 = require("../records/seed.record");
exports.seedRouter = (0, express_1.Router)();
exports.seedRouter
    .get('/', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const seedsList = yield seed_record_1.SeedRecord.listAll();
    res.json({
        seedsList,
    });
}))
    .get('/:seedId', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const seed = yield seed_record_1.SeedRecord.getOne(req.params.seedId);
    // const amountOfSeeds = await seed.countGivenSeeds();
    res.json({
        seed,
    });
}))
    .delete('/:idSeed', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const seed = yield seed_record_1.SeedRecord.getOne(req.params.idSeed); // get one SeedRecord
    if (!seed) {
        throw new errors_1.ValidationError('There is no such addition to bread.');
    }
    yield seed.delete();
    res.end();
}))
    .post('/', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const newSeed = new seed_record_1.SeedRecord(req.body);
    yield newSeed.insert();
    res.json(newSeed);
}))
    .patch('/:idSeed', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const { body } = req;
    const seed = yield seed_record_1.SeedRecord.getOne(req.params.idSeed); // get one seed
    if (seed === null) {
        throw new errors_1.ValidationError('The seed witch you are looking for does not exist.');
    }
    seed.count = body.newCount;
    try {
        yield seed.update();
        res.json(seed);
    }
    catch (error) {
        console.error('Error while updating the seed record:', error);
        throw error;
    }
}));
//# sourceMappingURL=seed.js.map